pcl::SVMTrain Class Reference

SVM (Support Vector Machines) training class for the SVM machine learning. More...

`#include <pcl/ml/svm_wrapper.h>`

Inheritance diagram for pcl::SVMTrain:

## Public Member Functions

| SVMTrain ()
| Constructor. More...
| ~SVMTrain ()
| Destructor. More...
void | setParameters (SVMParam param)
| Change default training parameters (pcl::SVMParam). More...
SVMParam | getParameters ()
| Return the current training parameters. More...
SVMModel | getClassifierModel ()
| Return the result of the training. More...
void | setInputTrainingSet (std::vector< SVMData > training_set)
| It adds/store the training set with labelled data. More...
std::vector< SVMData > | getInputTrainingSet ()
| Return the current training set. More...
void | resetTrainingSet ()
| Reset the training set. More...
bool | trainClassifier ()
| Start the training of the SVM classifier. More...
bool | loadProblem (const char *filename)
| Read in a problem (in svmlight format). More...
void | setDebugMode (bool in)
| Set to 1 for debugging info. More...
bool | saveTrainingSet (const char *filename)
| Save the raw training set in a file (in svmlight format). More...
bool | saveNormTrainingSet (const char *filename)
| Save the normalized training set in a file (in svmlight format). More...
Public Member Functions inherited from pcl::SVM
| SVM ()
| Constructor. More...
| ~SVM ()
| Destructor. More...
void | getLabel (std::vector< int > &labels)
| Return the labels order from the classifier model. More...
void | saveClassifierModel (const char *filename)
| Save the classifier model in an extern file (in svmlight format). More...

## Protected Member Functions

void | doCrossValidation ()
| To cross validate the classifier. More...
void | scaleFactors (std::vector< SVMData > training_set, svm_scaling &scaling)
| It extracts scaling factors from the input training_set. More...
Protected Member Functions inherited from pcl::SVM
char * | readline (FILE *input)
| To read a line from the input file. More...
void | exitInputError (int line_num)
| Outputs an error in file reading. More...
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
void | adaptInputToLibSVM (std::vector< SVMData > training_set, svm_problem &prob)
| Convert the input format (vector of SVMData) into a readable format for libSVM. More...
void | adaptLibSVMToInput (std::vector< SVMData > &training_set, svm_problem prob)
| Convert the libSVM format (svm_problem) into a easier output format. More...
bool | loadProblem (const char *filename, svm_problem &prob)
| Load a problem from an extern file. More...
bool | saveProblem (const char *filename, bool labelled)
| Save the raw problem in an extern file. More...
bool | saveProblemNorm (const char *filename, svm_problem prob_, bool labelled)
| Save the problem (with normalized values) in an extern file. More...

## Protected Attributes

bool | debug_
int | cross_validation_
int | nr_fold_
Protected Attributes inherited from pcl::SVM
std::vector< SVMData > | training_set_
svm_problem | prob_
SVMModel | model_
svm_scaling | scaling_
SVMParam | param_
std::string | class_name_
char * | line_
int | max_line_len_
bool | labelled_training_set_

## Additional Inherited Members

Static Protected Member Functions inherited from pcl::SVM
static void | printNull (const char *)
| Set for output printings during classification. More...

## Detailed Description

SVM (Support Vector Machines) training class for the SVM machine learning.

It creates a model for the classifier from a labelled input dataset. OPTIONAL: pcl::SVMParam has to be given as input to vary the default training method and parameters.

Definition at line 236 of file svm_wrapper.h.

## Constructor & Destructor Documentation

## SVMTrain()

pcl::SVMTrain::SVMTrain | ( |  | ) |

inline

Constructor.

Definition at line 264 of file svm_wrapper.h.

## ~SVMTrain()

pcl::SVMTrain::~SVMTrain | ( |  | ) |

inline

Destructor.

Definition at line 271 of file svm_wrapper.h.

## Member Function Documentation

## doCrossValidation()

void pcl::SVMTrain::doCrossValidation | ( |  | ) |

protected

To cross validate the classifier.

It is automatic for probability estimate.

## getClassifierModel()

SVMModel pcl::SVMTrain::getClassifierModel | ( |  | ) |

inline

Return the result of the training.

Definition at line 293 of file svm_wrapper.h.

## getInputTrainingSet()

std::vector<SVMData> pcl::SVMTrain::getInputTrainingSet | ( |  | ) |

inline

Return the current training set.

Definition at line 307 of file svm_wrapper.h.

## getParameters()

SVMParam pcl::SVMTrain::getParameters | ( |  | ) |

inline

Return the current training parameters.

Definition at line 286 of file svm_wrapper.h.

## loadProblem()

bool pcl::SVMTrain::loadProblem | ( | const char * | filename | ) |

inline

Read in a problem (in svmlight format).

Returns
  false if fails.

Definition at line 327 of file svm_wrapper.h.

References pcl::SVM::loadProblem().

## resetTrainingSet()

void pcl::SVMTrain::resetTrainingSet | ( |  | ) |

inline

Reset the training set.

Definition at line 314 of file svm_wrapper.h.

## saveNormTrainingSet()

bool pcl::SVMTrain::saveNormTrainingSet | ( | const char * | filename | ) |

inline

Save the normalized training set in a file (in svmlight format).

Returns
  false if fails.

Definition at line 355 of file svm_wrapper.h.

References pcl::SVM::saveProblemNorm().

## saveTrainingSet()

bool pcl::SVMTrain::saveTrainingSet | ( | const char * | filename | ) |

inline

Save the raw training set in a file (in svmlight format).

Returns
  false if fails.

Definition at line 347 of file svm_wrapper.h.

References pcl::SVM::saveProblem().

## scaleFactors()

void pcl::SVMTrain::scaleFactors | ( | std::vector< SVMData > | training_set,
|  | svm_scaling & | scaling
| ) |  |

protected

It extracts scaling factors from the input training_set.

The scaling of the training_set is a mandatory for a good training of the classifier.

## setDebugMode()

void pcl::SVMTrain::setDebugMode | ( | bool | in | ) |

inline

Set to 1 for debugging info.

Definition at line 334 of file svm_wrapper.h.

## setInputTrainingSet()

void pcl::SVMTrain::setInputTrainingSet | ( | std::vector< SVMData > | training_set | ) |

inline

It adds/store the training set with labelled data.

Definition at line 300 of file svm_wrapper.h.

## setParameters()

void pcl::SVMTrain::setParameters | ( | SVMParam | param | ) |

inline

Change default training parameters (pcl::SVMParam).

Definition at line 279 of file svm_wrapper.h.

## trainClassifier()

bool pcl::SVMTrain::trainClassifier | ( |  | ) |

Start the training of the SVM classifier.

Returns
  false if fails.

## Member Data Documentation

## cross_validation_

int pcl::SVMTrain::cross_validation_

protected

Definition at line 250 of file svm_wrapper.h.

## debug_

bool pcl::SVMTrain::debug_

protected

Definition at line 249 of file svm_wrapper.h.

## nr_fold_

int pcl::SVMTrain::nr_fold_

protected

Definition at line 251 of file svm_wrapper.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/ml/include/pcl/ml/svm_wrapper.h